// TabRoms.cpp : implementation file
//

#include "stdafx.h"
#include "o2Launcher.h"
#include "TabRoms.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabRoms dialog


CTabRoms::CTabRoms(CWnd* pParent /*=NULL*/)
	: CDialog(CTabRoms::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTabRoms)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CTabRoms::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTabRoms)
	DDX_Control(pDX, IDC_LAUNCH, m_LaunchButton);
	DDX_Control(pDX, IDC_MANUAL, m_ManualButton);
	DDX_Control(pDX, IDC_COVER, m_CoverButton);
	DDX_Control(pDX, IDC_SCREENSHOT, m_Screenshot);
	DDX_Control(pDX, IDC_ROMS_LIST, m_RomsList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTabRoms, CDialog)
	//{{AFX_MSG_MAP(CTabRoms)
	ON_NOTIFY(TVN_SELCHANGED, IDC_ROMS_LIST, OnSelchangedRomsList)
	ON_BN_CLICKED(IDC_COVER, OnCover)
	ON_BN_CLICKED(IDC_MANUAL, OnManual)
	ON_BN_CLICKED(IDC_LAUNCH, OnLaunch)
	ON_NOTIFY(NM_DBLCLK, IDC_ROMS_LIST, OnDblclkRomsList)
	ON_WM_PAINT()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTabRoms message handlers

BOOL CTabRoms::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_CoverButton.bmpEnabled  = IDB_COVER_ENABLED;
	m_CoverButton.bmpDisabled = IDB_COVER_DISABLED;
	m_ManualButton.bmpEnabled = IDB_MANUAL_ENABLED;
	m_ManualButton.bmpDisabled = IDB_MANUAL_DISABLED;
	m_LaunchButton.bmpEnabled = IDB_LAUNCH;
	m_LaunchButton.bmpDisabled = IDB_LAUNCH;
	m_ManualButton.EnableWindow(FALSE);
	m_CoverButton.EnableWindow(FALSE);

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTabRoms::OnSelchangedRomsList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here


	if (!m_settings->refreshRoms)
	{

		CItem gameItem;
		HBITMAP bmp2=NULL;

		HTREEITEM treeItem = m_RomsList.GetSelectedItem();

		POSITION pos = m_GameList.GetHeadPosition();
		if (pos!=NULL)
		{
			for (int i=0;i<m_GameList.GetCount();i++)
			{
				gameItem = m_GameList.GetNext(pos);
				if (gameItem.treeItem == treeItem)
				{

					if (gameItem.strCover.IsEmpty())
						m_CoverButton.EnableWindow(FALSE);
					else
						m_CoverButton.EnableWindow(TRUE);
					

					if (gameItem.strManual.IsEmpty())
						m_ManualButton.EnableWindow(FALSE);
					else
						m_ManualButton.EnableWindow(TRUE);


					CString strAux;
					strAux.Format("%s\\%s",m_settings->m_strShotDir,gameItem.strShot);

					 bmp2 = (HBITMAP)LoadImage(GetModuleHandle(NULL),
								strAux,
								IMAGE_BITMAP,
								320,
								240,
								LR_LOADFROMFILE);

					 if (bmp2!=NULL)
						 m_Screenshot.SetBitmap(bmp2);
					 else
					 {
						 bmp2 = LoadBitmap(GetModuleHandle(NULL),
							 MAKEINTRESOURCE(IDB_NOSCREEN));
						 m_Screenshot.SetBitmap(bmp2);
					 }

				}
			}
		}

	}	
	*pResult = 0;
}


void CTabRoms::OnCover() 
{
	// TODO: Add your control notification handler code here

	CItem gameItem;
	HTREEITEM treeItem = m_RomsList.GetSelectedItem();

	POSITION pos = m_GameList.GetHeadPosition();
	if (pos!=NULL)
	{
		for (int i=0;i<m_GameList.GetCount();i++)
		{
			gameItem = m_GameList.GetNext(pos);
			if (gameItem.treeItem == treeItem)
			{
				CString strAux;
				strAux.Format("\"%s\" \"%s\\%s\"",m_settings->m_strPictureViewer,
					m_settings->m_strCoverDir,
					gameItem.strCover);


				STARTUPINFO si;
				PROCESS_INFORMATION pi;
				
				memset(&si, 0, sizeof(STARTUPINFO));
				si.cb = sizeof(si);
				si.dwFlags = STARTF_USESHOWWINDOW;
				si.wShowWindow = SW_SHOWNORMAL;

				int ret=CreateProcess(NULL, 
										(char *)(const char *)strAux,
										NULL, 
										NULL, 
										FALSE, 
										NORMAL_PRIORITY_CLASS, 
										NULL, 
										NULL, 
										&si, 
										&pi); 

				if (!ret)
				{
					MessageBox("Unable to start Picture Viewer",NULL,MB_OK|MB_ICONERROR);
				}
	

			}
		}
	}
}


void CTabRoms::OnManual() 
{
	// TODO: Add your control notification handler code here
	CItem gameItem;
	HTREEITEM treeItem = m_RomsList.GetSelectedItem();

	POSITION pos = m_GameList.GetHeadPosition();
	if (pos!=NULL)
	{
		for (int i=0;i<m_GameList.GetCount();i++)
		{
			gameItem = m_GameList.GetNext(pos);
			if (gameItem.treeItem == treeItem)
			{
				CString strAux;
				strAux.Format("\"%s\" \"%s\\%s\"",m_settings->m_strTextViewer,
					m_settings->m_strManualDir,
					gameItem.strManual);


				STARTUPINFO si;
				PROCESS_INFORMATION pi;
				
				memset(&si, 0, sizeof(STARTUPINFO));
				si.cb = sizeof(si);
				si.dwFlags = STARTF_USESHOWWINDOW;
				si.wShowWindow = SW_SHOWNORMAL;

				int ret=CreateProcess(NULL, 
										(char *)(const char *)strAux,
										NULL, 
										NULL, 
										FALSE, 
										NORMAL_PRIORITY_CLASS, 
										NULL, 
										NULL, 
										&si, 
										&pi); 

				if (!ret)
				{
					MessageBox("Unable to start Picture Viewer",NULL,MB_OK|MB_ICONERROR);
				}
	


			}
		}
	}

}


void CTabRoms::OnLaunch() 
{
	// TODO: Add your control notification handler code here

	CItem gameItem;
	CString strAux;

	HTREEITEM treeItem = m_RomsList.GetSelectedItem();

	MountCommandLine();

	POSITION pos = m_GameList.GetHeadPosition();
	if (pos!=NULL)
	{
		for (int i=0;i<m_GameList.GetCount();i++)
		{
			gameItem = m_GameList.GetNext(pos);
			if (gameItem.treeItem == treeItem)
			{
				CString strAux2;
				
				strAux2.Format("\"-scshot=%s\\%s\"",m_settings->m_strShotDir,gameItem.strShot);

				strAux.Format("o2em \"%s\\%s\" %s %s",m_settings->m_strRomDir,gameItem.strFile,m_strCommand,strAux2);

				STARTUPINFO si;
				PROCESS_INFORMATION pi;
				
				memset(&si, 0, sizeof(STARTUPINFO));
				si.cb = sizeof(si);
				si.dwFlags = STARTF_USESHOWWINDOW;
				si.wShowWindow = SW_SHOWNORMAL;

				char *tmp = _tempnam(m_settings->m_strEmuDir,"o2emlog");
			
				SECURITY_ATTRIBUTES sa;
				sa.nLength = sizeof(SECURITY_ATTRIBUTES);
				sa.lpSecurityDescriptor = NULL;
				sa.bInheritHandle = TRUE;

				HANDLE hnd = CreateFile(tmp,GENERIC_WRITE,0,&sa,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

				if (hnd!=INVALID_HANDLE_VALUE) {
					AllocConsole();
					si.hStdOutput = GetStdHandle(STD_OUTPUT_HANDLE);
					si.hStdInput = GetStdHandle(STD_INPUT_HANDLE);
					si.hStdError = hnd;
					si.dwFlags |= STARTF_USESTDHANDLES;
					FreeConsole();
				}

				////////////////////////////////////////////////////////

				char szOldDir[512];
				GetCurrentDirectory(512,szOldDir);
				SetCurrentDirectory(m_settings->m_strEmuDir);

				////////////////////////////////////////////////////////


				int ret=CreateProcess(NULL, 
										(char *)(const char *)strAux,
										NULL, 
										NULL, 
										TRUE, 
										NORMAL_PRIORITY_CLASS|CREATE_NO_WINDOW, 
										NULL, 
										NULL, 
										&si, 
										&pi); 

				SetCurrentDirectory(szOldDir);


				if (!ret)
				{
					CString strMsg;
					strMsg.Format("Unable to execute o2em.exe at %s",m_settings->m_strEmuDir);
					MessageBox(strMsg,"Launcher Error",MB_OK|MB_ICONERROR);
					if (hnd!=INVALID_HANDLE_VALUE) {
						CloseHandle(hnd);
						DeleteFile(tmp);
					}
				} else {

					m_ParentDialog->ShowWindow(SW_HIDE);

					DWORD extcode;

					do {
						Sleep(100);
						GetExitCodeProcess(pi.hProcess,&extcode);
					} while(extcode == STILL_ACTIVE);

					m_ParentDialog->ShowWindow(SW_SHOW);

					if (extcode) {
						if (hnd!=INVALID_HANDLE_VALUE) {
							CloseHandle(hnd);

							char s[300];
							strcpy(s,"");
							FILE *f = fopen(tmp,"r");
							if (f) {
								while (fgets(s,299,f));
								fclose(f);
								if (strlen(s)<1)
									MessageBox("Error running O2EM.  Maybe the Allegro DLL is missing...","Error",MB_OK|MB_ICONERROR);
								else
									MessageBox(s,"O2EM returned an error:",MB_OK|MB_ICONERROR);
							} else {
								MessageBox("Unable to execute O2EM.  Maybe the Allegro DLL is missing...","Error",MB_OK|MB_ICONERROR);
							}

							DeleteFile(tmp);

						} else {
							MessageBox("O2EM returned an error","Error",MB_OK|MB_ICONERROR);
						}
					} else {
						if (hnd!=INVALID_HANDLE_VALUE) {
							CloseHandle(hnd);
							DeleteFile(tmp);
						}
					}
				}
			}
		}
	}
}


BOOL CTabRoms::MountCommandLine()
{
	CString strAux,strCommand;
	int nAux;

	strCommand.Empty();

	// Window Size
	nAux = m_settings->m_WindowSize.GetCurSel() + 1;
	strAux.Format(" -wsize=%d",nAux);
	strCommand += strAux;

	if (m_settings->m_bFullscreen)
		strCommand += " -fullscreen";
	else
		strCommand += " -fullscreen=0";


	if (m_settings->m_bScanlines)
		strCommand += " -scanlines";
	else
		strCommand += " -scanlines=0";

	if (m_settings->m_bEnableFilter)
		strCommand += " -filter";
	else
		strCommand += " -filter=0";

	if (m_settings->m_bEuroMode)
		strCommand += " -euro";
	else
		strCommand += " -euro=0";

	if (m_settings->m_bNoAudio)
		strCommand += " -nosound";
	else
		strCommand += " -nosound=0";

	if (m_settings->m_bNoVoice)
		strCommand += " -novoice";
	else
		strCommand += " -novoice=0";

	if (!m_settings->m_bNoAudio)
	{
		strAux.Format(" -svolume=%d",m_settings->m_nAudioVolume);
		strCommand += strAux;
	}

	if (!m_settings->m_bNoVoice)
	{
		strAux.Format(" -vvolume=%d",m_settings->m_nVoiceVolume);
		strCommand += strAux;
	}

	
	if (m_settings->m_bDebug)
		strCommand += " -debug";
	else
		strCommand += " -debug=0";

	if (m_settings->m_bSpeedLimiter)
		strCommand += " -nolimit";
	else
		strCommand += " -nolimit=0";

	if (!m_settings->m_bSpeedLimiter)
	{
		strAux.Format(" -speed=%d",m_settings->m_nSpeed);
		strCommand += strAux;
	}

	//Stick 1
	nAux = m_settings->m_Stick1.GetCurSel();
	if (nAux>=0)
		strAux.Format(" -s1=%d",nAux);
	else {
		CString s;
		m_settings->m_Stick1.GetWindowText(s);
		strAux.Format(" -s1=%s",s);
	}
	strCommand += strAux;

	//Stick 2
	nAux = m_settings->m_Stick2.GetCurSel();
	if (nAux>=0)
		strAux.Format(" -s2=%d",nAux);
	else {
		CString s;
		m_settings->m_Stick2.GetWindowText(s);
		strAux.Format(" -s2=%s",s);
	}
	strCommand += strAux;

	//Bios
	strAux.Format(" \"-bios=%s\"",m_settings->m_strRomFile);
	strCommand += strAux;

	m_strCommand = strCommand;

	return TRUE;
}


void CTabRoms::OnDblclkRomsList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here

	OnLaunch();
	
	*pResult = 0;
}

void CTabRoms::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	RECT rect;
	CBrush brush;
	CPoint point;

	
	// TODO: Add your message handler code here

		
//	brush.CreateSolidBrush(RGB(20,20,20));
	CBitmap bmp;
	bmp.LoadBitmap(IDB_PATTERN);
	brush.CreatePatternBrush(&bmp);
	GetClientRect(&rect);
	
	dc.FillRect(&rect,&brush);

	
	// Do not call CDialog::OnPaint() for painting messages
}


int CTabRoms::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	return 0;
}

BOOL CTabRoms::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == WM_KEYDOWN) {
		switch (pMsg->wParam)
		{
		case VK_ESCAPE:
			return TRUE;
		case VK_RETURN:
			OnLaunch();
			return TRUE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}
