// TabSettings.cpp : implementation file
//

#include "stdafx.h"
#include "o2Launcher.h"
#include "TabSettings.h"
#include "Checksum.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

///////////////////////////////



///////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// CTabSettings dialog


CTabSettings::CTabSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CTabSettings::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTabSettings)
	m_bFullscreen = FALSE;
	m_bScanlines = FALSE;
	m_nAudioVolume = 0;
	m_nVoiceVolume = 0;
	m_bNoAudio = FALSE;
	m_bNoVoice = FALSE;
	m_nSpeed = 0;
	m_bSpeedLimiter = FALSE;
	m_bDebug = FALSE;
	m_strRomDir = _T("");
	m_strEmuDir = _T("");
	m_strShotDir = _T("");
	m_strPictureViewer = _T("");
	m_strTextViewer = _T("");
	m_strCoverDir = _T("");
	m_strManualDir = _T("");
	m_strRomFile = _T("");
	m_bEnableFilter = FALSE;
	m_bEuroMode = FALSE;
	//}}AFX_DATA_INIT


}


void CTabSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTabSettings)
	DDX_Control(pDX, IDC_COMBO_STICK2, m_Stick2);
	DDX_Control(pDX, IDC_COMBO_STICK1, m_Stick1);
	DDX_Control(pDX, IDC_SPEED_SLIDER, m_SpeedSlider);
	DDX_Control(pDX, IDC_VOICE_SLIDER, m_VoiceSlider);
	DDX_Control(pDX, IDC_AUDIO_SLIDER, m_AudioSlider);
	DDX_Control(pDX, IDC_CWINDOWSIZE, m_WindowSize);
	DDX_Check(pDX, IDC_FULLSCREEN, m_bFullscreen);
	DDX_Check(pDX, IDC_SCANLINES, m_bScanlines);
	DDX_Text(pDX, IDC_AUDIOVOL, m_nAudioVolume);
	DDX_Text(pDX, IDC_VOICEVOL, m_nVoiceVolume);
	DDX_Check(pDX, IDC_NOAUDIO, m_bNoAudio);
	DDX_Check(pDX, IDC_NOVOICE, m_bNoVoice);
	DDX_Text(pDX, IDC_SPEED, m_nSpeed);
	DDX_Check(pDX, IDC_SPEEDLIMITER, m_bSpeedLimiter);
	DDX_Check(pDX, IDC_DEBUGMODE, m_bDebug);
	DDX_Text(pDX, IDC_EDIT1, m_strRomDir);
	DDX_Text(pDX, IDC_EDIT3, m_strEmuDir);
	DDX_Text(pDX, IDC_EDIT4, m_strShotDir);
	DDX_Text(pDX, IDC_EDIT5, m_strPictureViewer);
	DDX_Text(pDX, IDC_EDIT6, m_strTextViewer);
	DDX_Text(pDX, IDC_EDIT7, m_strCoverDir);
	DDX_Text(pDX, IDC_EDIT8, m_strManualDir);
	DDX_Text(pDX, IDC_EDIT9, m_strRomFile);
	DDX_Check(pDX, IDC_ENABLE_FILTER, m_bEnableFilter);
	DDX_Check(pDX, IDC_EURO_MODE, m_bEuroMode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTabSettings, CDialog)
	//{{AFX_MSG_MAP(CTabSettings)
	ON_BN_CLICKED(IDC_FULLSCREEN, OnFullscreen)
	ON_BN_CLICKED(IDC_SCANLINES, OnScanlines)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_AUDIO_SLIDER, OnReleasedcaptureAudioSlider)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_VOICE_SLIDER, OnReleasedcaptureVoiceSlider)
	ON_BN_CLICKED(IDC_NOAUDIO, OnNoaudio)
	ON_BN_CLICKED(IDC_NOVOICE, OnNovoice)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SPEED_SLIDER, OnReleasedcaptureSpeedSlider)
	ON_BN_CLICKED(IDC_SPEEDLIMITER, OnSpeedlimiter)
	ON_BN_CLICKED(IDC_DEBUGMODE, OnDebugmode)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_BROWSE3, OnBrowse3)
	ON_BN_CLICKED(IDC_BROWSE4, OnBrowse4)
	ON_BN_CLICKED(IDC_BROWSE6, OnBrowse6)
	ON_BN_CLICKED(IDC_BROWSE5, OnBrowse5)
	ON_BN_CLICKED(IDC_BROWSE7, OnBrowse7)
	ON_BN_CLICKED(IDC_BROWSE8, OnBrowse8)
	ON_BN_CLICKED(IDC_BROWSE9, OnBrowse9)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_ENABLE_FILTER, OnEnableFilter)
	ON_BN_CLICKED(IDC_EURO_MODE, OnEuroMode)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTabSettings message handlers

BOOL CTabSettings::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	m_WindowSize.InitStorage(4,20);
	m_WindowSize.InsertString(0,"Tiny (1)");
	m_WindowSize.InsertString(1,"Normal (2)");
	m_WindowSize.InsertString(2,"Large (3)");
	m_WindowSize.InsertString(3,"Giant (4)");
	m_WindowSize.SetCurSel(1);

	///////////////////////////////////////////////////////////////

	m_Stick1.InitStorage(4,80);
	m_Stick1.LimitText(80);
	m_Stick1.InsertString(0,"Disable");
	m_Stick1.InsertString(1,"Default right keys");
	m_Stick1.InsertString(2,"Default left keys");
	m_Stick1.InsertString(3,"Joystick");
	m_Stick1.SetCurSel(1);
	
	///////////////////////////////////////////

	m_Stick2.InitStorage(4,80);
	m_Stick2.LimitText(80);
	m_Stick2.InsertString(0,"Disable");
	m_Stick2.InsertString(1,"Default right keys");
	m_Stick2.InsertString(2,"Default left keys");
	m_Stick2.InsertString(3,"Joystick");
	m_Stick2.SetCurSel(2);
	
	///////////////////////////////////////////

	m_AudioSlider.SetRange(0,100,TRUE);
	m_AudioSlider.SetPos(100);
	m_nAudioVolume = 100;

	m_VoiceSlider.SetRange(0,100,TRUE);
	m_VoiceSlider.SetPos(100);
	m_nVoiceVolume = 100;

	m_SpeedSlider.SetRange(0,200,TRUE);
	m_SpeedSlider.SetPos(100);
	m_nSpeed = 100;


	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTabSettings::OnFullscreen() 
{
	// TODO: Add your control notification handler code here
	(m_bFullscreen) ? m_bFullscreen = FALSE : m_bFullscreen = TRUE;
	
}

void CTabSettings::OnScanlines() 
{
	// TODO: Add your control notification handler code here
	(m_bScanlines) ? m_bScanlines = FALSE : m_bScanlines = TRUE;
	
}

void CTabSettings::OnReleasedcaptureAudioSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here

	m_nAudioVolume = m_AudioSlider.GetPos();

	UpdateData(FALSE);
	
	*pResult = 0;
}

void CTabSettings::OnReleasedcaptureVoiceSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here

	m_nVoiceVolume = m_VoiceSlider.GetPos();

	UpdateData(FALSE);
	
	*pResult = 0;
}

void CTabSettings::OnNoaudio() 
{
	// TODO: Add your control notification handler code here

	(m_bNoAudio) ? m_bNoAudio = FALSE : m_bNoAudio = TRUE;
}

void CTabSettings::OnNovoice() 
{
	// TODO: Add your control notification handler code here
	
	(m_bNoVoice) ? m_bNoVoice = FALSE : m_bNoVoice = TRUE;
	
}

void CTabSettings::OnReleasedcaptureSpeedSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here

	m_nSpeed = m_SpeedSlider.GetPos();

	UpdateData(FALSE);

	
	*pResult = 0;
}

void CTabSettings::OnSpeedlimiter() 
{
	// TODO: Add your control notification handler code here

	(m_bSpeedLimiter) ? m_bSpeedLimiter = FALSE : m_bSpeedLimiter = TRUE;
	
}

void CTabSettings::OnDebugmode() 
{
	// TODO: Add your control notification handler code here
	(m_bDebug) ? m_bDebug = FALSE : m_bDebug = TRUE;

	
}

void CTabSettings::OnBrowse() 
{
	// TODO: Add your control notification handler code here

	BROWSEINFO bi;
	ITEMIDLIST *idList;
	char szBuffer[MAX_PATH];
	char szTitle[]="Select Games Directory";
	CString strOldRomDir = m_strRomDir;
	
	bi.hwndOwner = m_hWnd;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = szBuffer;
	bi.lpszTitle = szTitle;
	bi.ulFlags = NULL;
	bi.lpfn = NULL;
	

	idList = SHBrowseForFolder(&bi);
	if (idList!=NULL)
	{
		if (SHGetPathFromIDList(idList,szBuffer))
		{
			UpdateData(TRUE);
			m_strRomDir = szBuffer;
			UpdateData(FALSE);
		}
	}

	if (strOldRomDir!=m_strRomDir)
		refreshRoms = TRUE;
	

}

void CTabSettings::OnBrowse3() 
{
	// TODO: Add your control notification handler code here
	
	BROWSEINFO bi;
	ITEMIDLIST *idList;
	char szBuffer[MAX_PATH];
	char szTitle[]="Select the O2EM Directory";
	
	bi.hwndOwner = m_hWnd;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = szBuffer;
	bi.lpszTitle = szTitle;
	bi.ulFlags = NULL;
	bi.lpfn = NULL;
	

	idList = SHBrowseForFolder(&bi);
	if (idList!=NULL)
	{
		if (SHGetPathFromIDList(idList,szBuffer))
		{
			UpdateData(TRUE);
			m_strEmuDir = szBuffer;
			UpdateData(FALSE);
		}
	}
	
}

void CTabSettings::OnBrowse4() 
{
	// TODO: Add your control notification handler code here
	BROWSEINFO bi;
	ITEMIDLIST *idList;
	CString strOldShotDir;
	char szBuffer[MAX_PATH];
	char szTitle[]="Select the Screenshots Directory";
	
	bi.hwndOwner = m_hWnd;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = szBuffer;
	bi.lpszTitle = szTitle;
	bi.ulFlags = NULL;
	bi.lpfn = NULL;
	

	idList = SHBrowseForFolder(&bi);
	if (idList!=NULL)
	{
		if (SHGetPathFromIDList(idList,szBuffer))
		{
			UpdateData(TRUE);
			m_strShotDir = szBuffer;
			UpdateData(FALSE);
		}
	}
	if (strOldShotDir!=m_strShotDir)
		refreshRoms = TRUE;
	
}

void CTabSettings::OnBrowse6() 
{
	// TODO: Add your control notification handler code here
	// Picture Viewer

	////////////////////////////////////////////////////////

	char szOldDir[512];
	GetCurrentDirectory(512,szOldDir);

	////////////////////////////////////////////////////////


	static char BASED_CODE szFilter[] = "Program Files (*.exe)|*.exe||";
 

	CFileDialog fd(TRUE, 
					".exe",
					NULL,
					OFN_ENABLESIZING|OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST,
					szFilter,
					this);

	if (fd.DoModal()==IDOK)
	{
		UpdateData(TRUE);
		m_strPictureViewer = fd.GetPathName();
		UpdateData(FALSE);
	}

	SetCurrentDirectory(szOldDir);
	
}

void CTabSettings::OnBrowse5() 
{
	// TODO: Add your control notification handler code here
	// Text Viewer
	static char BASED_CODE szFilter[] = "Program Files (*.exe)|*.exe||";

	////////////////////////////////////////////////////////

	char szOldDir[512];
	GetCurrentDirectory(512,szOldDir);

	////////////////////////////////////////////////////////

 

	CFileDialog fd(TRUE, 
					".exe",
					NULL,
					OFN_ENABLESIZING|OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST,
					szFilter,
					this);

	if (fd.DoModal()==IDOK)
	{
		UpdateData(TRUE);
		m_strTextViewer = fd.GetPathName();
		UpdateData(FALSE);
	}

	SetCurrentDirectory(szOldDir);

	
}

void CTabSettings::OnBrowse7() 
{
	// TODO: Add your control notification handler code here
	BROWSEINFO bi;
	ITEMIDLIST *idList;
	char szBuffer[MAX_PATH];
	char szTitle[]="Select the Covers Directory";
	
	bi.hwndOwner = m_hWnd;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = szBuffer;
	bi.lpszTitle = szTitle;
	bi.ulFlags = NULL;
	bi.lpfn = NULL;
	

	idList = SHBrowseForFolder(&bi);
	if (idList!=NULL)
	{
		if (SHGetPathFromIDList(idList,szBuffer))
		{
			UpdateData(TRUE);
			m_strCoverDir = szBuffer;
			UpdateData(FALSE);
		}
	}
	

	
}

void CTabSettings::OnBrowse8() 
{
	// TODO: Add your control notification handler code here

	BROWSEINFO bi;
	ITEMIDLIST *idList;
	char szBuffer[MAX_PATH];
	char szTitle[]="Select the Manuals Directory";
	
	bi.hwndOwner = m_hWnd;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = szBuffer;
	bi.lpszTitle = szTitle;
	bi.ulFlags = NULL;
	bi.lpfn = NULL;
	

	idList = SHBrowseForFolder(&bi);
	if (idList!=NULL)
	{
		if (SHGetPathFromIDList(idList,szBuffer))
		{
			UpdateData(TRUE);
			m_strManualDir = szBuffer;
			UpdateData(FALSE);
		}
	}
	


	
}

void CTabSettings::OnBrowse9() 
{
	// TODO: Add your control notification handler code here
	// Rom File

	static char BASED_CODE szFilter[] = "Bios Files (*.bin; *.rom)|*.bin; *.rom||";

	////////////////////////////////////////////////////////

	char szOldDir[512];
	GetCurrentDirectory(512,szOldDir);

	////////////////////////////////////////////////////////

 	CFileDialog fd(TRUE, 
					".bin",
					NULL,
					OFN_ENABLESIZING|OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST,
					szFilter,
					this);

	if (fd.DoModal()==IDOK)
	{
		CChecksum checksum;
		unsigned long crc = checksum.crc32_file(fd.GetPathName());

		if ((crc==0x8016a315) || (crc==0xE20A9F41))
		{
			UpdateData(TRUE);
			m_strRomFile = fd.GetPathName();
			UpdateData(FALSE);
		} else {
			if (MessageBox("This file does not look like a valid O2 Bios. Use it anyway ?",NULL,MB_YESNO|MB_ICONWARNING)!=IDNO){
				UpdateData(TRUE);
				m_strRomFile = fd.GetPathName();
				UpdateData(FALSE);
			}
		}
			
	}

	SetCurrentDirectory(szOldDir);

	

	
}

void CTabSettings::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
}

BOOL CTabSettings::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == WM_KEYDOWN) {
		switch (pMsg->wParam)
		{
		case VK_ESCAPE:
			return TRUE;
		case VK_RETURN:
			return TRUE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CTabSettings::OnEnableFilter() 
{
	(m_bEnableFilter) ? m_bEnableFilter = FALSE : m_bEnableFilter = TRUE;
}

void CTabSettings::OnEuroMode() 
{
	(m_bEuroMode) ? m_bEuroMode = FALSE : m_bEuroMode = TRUE;
}
