// o2LauncherDlg.cpp : implementation file
//

#include "stdafx.h"
#include "o2Launcher.h"
#include "o2LauncherDlg.h"
#include "RomDirDlg.h"
#include "TabRoms.h"
#include "TabSettings.h"
#include "Item.h"
#include "Checksum.h"
#include "AboutDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CO2LauncherDlg dialog

CO2LauncherDlg::CO2LauncherDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CO2LauncherDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CO2LauncherDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CO2LauncherDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CO2LauncherDlg)
	DDX_Control(pDX, IDC_TABS, m_Tabs);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CO2LauncherDlg, CDialog)
	//{{AFX_MSG_MAP(CO2LauncherDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(NM_DBLCLK, IDC_ROMS_LIST, OnDblclkRomsList)
	ON_BN_CLICKED(IDC_LAUNCH, OnLaunch)
	ON_COMMAND(ID_ABOUT_ABOUT, OnAboutAbout)
	ON_WM_CLOSE()
	ON_COMMAND(ID_FILE_QUIT, OnFileQuit)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TABS, OnSelchangeTabs)
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_TOOLS_CRCCALCULATOR, OnToolsCrccalculator)
	ON_COMMAND(ID_TOOLS_EMULATORKEYS, OnToolsEmulatorkeys)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CO2LauncherDlg message handlers

BOOL CO2LauncherDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	///////////////////////////////////////////////////////
	
	m_TabRoms.m_settings = &m_TabSettings;
	m_TabRoms.m_ParentDialog = this;

	///////////////////////////////////////////////////////
	


	 TC_ITEM tci;
	 tci.mask = TCIF_TEXT | TCIF_IMAGE ;
	 //tci.image = 0;
	 tci.pszText = "roms           ";
	 m_Tabs.InsertItem(0,&tci);
	 tci.pszText = "settings       ";
	 m_Tabs.InsertItem(1,&tci);


	 RECT rect;
	 m_Tabs.GetItemRect(0, &rect);
 
	 m_TabRoms.Create(IDD_TAB_ROMS,&m_Tabs);
	 m_TabRoms.SetWindowPos(0,rect.left + 2, rect.bottom + 2,0,0,
		SWP_NOSIZE | SWP_NOZORDER);

 	 m_TabSettings.Create(IDD_TAB_SETTINGS,&m_Tabs);
	 m_TabSettings.SetWindowPos(0,rect.left + 2, rect.bottom + 2,0,0,
		SWP_NOSIZE | SWP_NOZORDER);

	 m_Tabs.SetCurSel(0);
	 m_TabRoms.ShowWindow(SW_SHOW);

 
	///////////////////////////////////////////////////////


	UpdateData(TRUE);

	CBitmap bmp;

	m_imgList.Create(16,16,ILC_COLOR8,0,4);
	bmp.LoadBitmap(IDB_ROM);
	m_imgList.Add(&bmp,RGB(20,20,20));
	bmp.Detach();

	bmp.LoadBitmap(IDB_UNKNOWN);
	m_imgList.Add(&bmp,RGB(20,20,20));
	bmp.Detach();


	m_TabRoms.m_RomsList.SetImageList(&m_imgList,TVSIL_NORMAL);
	m_TabRoms.m_RomsList.SetTextColor(RGB(0,155,255));
	m_TabRoms.m_RomsList.SetBkColor(RGB(0,0,0));

	///////////////////////////////////////////

	m_TabSettings.m_strRomDir = "roms";
	m_TabSettings.m_strShotDir = "shots";
	m_TabSettings.m_strEmuDir = "";
	m_TabSettings.m_strRomFile = "o2rom.bin";
	m_TabSettings.m_strCoverDir = "covers";
	m_TabSettings.m_strManualDir = "manuals";
	m_TabSettings.m_strPictureViewer = "";
	m_TabSettings.m_strTextViewer = "notepad.exe";

	
	///////////////////////////////////////////

	GetConfig();
	RefreshRomsList();

	m_TabRoms.m_RomsList.GetFocus();

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CO2LauncherDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting


	if (IsIconic())
	{

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CBrush brush;
		CRect rect;
	
		brush.CreateSolidBrush(RGB(20,20,20));
		GetClientRect(&rect);
		dc.FillRect(&rect,&brush);





		CDialog::OnPaint();
	}
}

HCURSOR CO2LauncherDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


BOOL CO2LauncherDlg::RefreshRomsList()
{
	CFileFind ff;
	HTREEITEM treeItem;
	CItem gameItem;
	char szBuffer[512];
	CString strIniFile,strSection;
	int nImage;
	CChecksum checksum;

	GetCurrentDirectory(512,szBuffer);
	strIniFile.Format("%s\\gamelist.ini",szBuffer);


	m_TabRoms.m_RomsList.DeleteAllItems();
	m_TabRoms.m_GameList.RemoveAll();


	BOOL bRoms = ff.FindFile(m_TabSettings.m_strRomDir + "\\*.bin",0);

	while(bRoms) 
	{
		bRoms = ff.FindNextFile();

		strSection.Format("%s\\%s",m_TabSettings.m_strRomDir,ff.GetFileName());
		unsigned long ulCrc = checksum.crc32_file(strSection);
		strSection.Format("%08lX",ulCrc);

		if ((strSection == "8016A315") || (strSection == "E20A9F41"))
			continue;

		if (GetPrivateProfileString(strSection,"NAME",ff.GetFileName(),szBuffer,512,strIniFile))
			gameItem.strName = szBuffer;
		else
			gameItem.strName = ff.GetFileName();


		if (GetPrivateProfileString(strSection,"SHOT","",szBuffer,512,strIniFile))
			gameItem.strShot = szBuffer;
		else
			gameItem.strShot = strSection + ".bmp";

		if (GetPrivateProfileString(strSection,"COVER","",szBuffer,512,strIniFile))
			gameItem.strCover = szBuffer;
		else
			gameItem.strCover = "";

		if (GetPrivateProfileString(strSection,"MANUAL","",szBuffer,512,strIniFile))
			gameItem.strManual = szBuffer;
		else
			gameItem.strManual = "";

		gameItem.strFile = ff.GetFileName();
		if (gameItem.strFile == gameItem.strName)
			nImage = 1;
		else 
			nImage = 0;

		treeItem = m_TabRoms.m_RomsList.InsertItem(TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE,
						  gameItem.strName,
						  nImage,                  // Image
						  nImage,                  // Selected Image
						  TVIS_BOLD,          // State
						  TVIF_STATE|TVIF_TEXT,          // State Mask
						  0,
						  NULL,
						  TVI_SORT);
		gameItem.treeItem = treeItem;

		m_TabRoms.m_GameList.AddTail(gameItem);

	} 

	m_TabSettings.refreshRoms = FALSE;
	m_TabRoms.m_RomsList.SelectItem(m_TabRoms.m_RomsList.GetFirstVisibleItem());

	return TRUE;

}


void CO2LauncherDlg::OnDblclkRomsList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here

	
	*pResult = 0;
}



void CO2LauncherDlg::OnLaunch() 
{
}

BOOL CO2LauncherDlg::MountCommandLine()
{
	return TRUE;
}

void CO2LauncherDlg::OnAboutAbout() 
{
	// TODO: Add your command handler code here

	CAboutDlg dlg;

	dlg.DoModal();
	
}

void CO2LauncherDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	
	char szBuffer[256];
	CString strIniFile;
	int nAux;

	GetCurrentDirectory(256,szBuffer);

	strIniFile.Format("%s\\o2launch.ini",szBuffer);


	WritePrivateProfileString("SETTINGS","ROMS_DIR",m_TabSettings.m_strRomDir,strIniFile);
	WritePrivateProfileString("SETTINGS","EMU_DIR",m_TabSettings.m_strEmuDir,strIniFile);
	WritePrivateProfileString("SETTINGS","ROM_FILE",m_TabSettings.m_strRomFile,strIniFile);
	WritePrivateProfileString("SETTINGS","SHOT_DIR",m_TabSettings.m_strShotDir,strIniFile);
	WritePrivateProfileString("SETTINGS","COVER_DIR",m_TabSettings.m_strCoverDir,strIniFile);
	WritePrivateProfileString("SETTINGS","MANUAL_DIR",m_TabSettings.m_strManualDir,strIniFile);
	WritePrivateProfileString("SETTINGS","PICVIEWER",m_TabSettings.m_strPictureViewer,strIniFile);
	WritePrivateProfileString("SETTINGS","TEXTVIEWER",m_TabSettings.m_strTextViewer,strIniFile);
	WritePrivateProfileString("SETTINGS","DEBUG",(m_TabSettings.m_bDebug) ? "1" : "0",strIniFile);
	WritePrivateProfileString("SETTINGS","NOAUDIO",(m_TabSettings.m_bNoAudio) ? "1" : "0",strIniFile);
	WritePrivateProfileString("SETTINGS","NOVOICE",(m_TabSettings.m_bNoVoice) ? "1" : "0",strIniFile);
	WritePrivateProfileString("SETTINGS","SCANLINES",(m_TabSettings.m_bScanlines) ? "1" : "0",strIniFile);
	WritePrivateProfileString("SETTINGS","EUROMODE",(m_TabSettings.m_bEuroMode) ? "1" : "0",strIniFile);
	WritePrivateProfileString("SETTINGS","ENABLEFILTER",(m_TabSettings.m_bEnableFilter) ? "1" : "0",strIniFile);
	WritePrivateProfileString("SETTINGS","FULLSCREEN",(m_TabSettings.m_bFullscreen) ? "1" : "0",strIniFile);
	WritePrivateProfileString("SETTINGS","SPEEDLIMITER",(m_TabSettings.m_bSpeedLimiter) ? "1" : "0",strIniFile);
	WritePrivateProfileString("SETTINGS","AUDIO",_itoa(m_TabSettings.m_nAudioVolume,szBuffer,10),strIniFile);
	WritePrivateProfileString("SETTINGS","VOICE",_itoa(m_TabSettings.m_nVoiceVolume,szBuffer,10),strIniFile);
	WritePrivateProfileString("SETTINGS","SPEED",_itoa(m_TabSettings.m_nSpeed,szBuffer,10),strIniFile);
	WritePrivateProfileString("SETTINGS","WINDOW",_itoa(m_TabSettings.m_WindowSize.GetCurSel(),szBuffer,10),strIniFile);

	nAux = m_TabSettings.m_Stick1.GetCurSel();
	if (nAux>=0)
		WritePrivateProfileString("SETTINGS","STICK1",_itoa(nAux,szBuffer,10),strIniFile);
	else {
		CString s;
		m_TabSettings.m_Stick1.GetWindowText(s);
		WritePrivateProfileString("SETTINGS","STICK1",s,strIniFile);
	}
	
	nAux = m_TabSettings.m_Stick2.GetCurSel();
	if (nAux>=0)
		WritePrivateProfileString("SETTINGS","STICK2",_itoa(nAux,szBuffer,10),strIniFile);
	else {
		CString s;
		m_TabSettings.m_Stick2.GetWindowText(s);
		WritePrivateProfileString("SETTINGS","STICK2",s,strIniFile);
	}

	CDialog::OnClose();
}

BOOL CO2LauncherDlg::GetConfig()
{

	char szBuffer[512];
	CString strIniFile;

	GetCurrentDirectory(512,szBuffer);

	strIniFile.Format("%s\\o2launch.ini",szBuffer);

	if (GetPrivateProfileString("SETTINGS","ROMS_DIR","roms",szBuffer,512,strIniFile))
		m_TabSettings.m_strRomDir = szBuffer;
	else
		m_TabSettings.m_strRomDir = "roms";

	if (GetPrivateProfileString("SETTINGS","EMU_DIR","",szBuffer,512,strIniFile))
		m_TabSettings.m_strEmuDir = szBuffer;
	else
		m_TabSettings.m_strEmuDir = "";

	if (GetPrivateProfileString("SETTINGS","ROM_FILE","o2rom.bin",szBuffer,512,strIniFile))
		m_TabSettings.m_strRomFile = szBuffer;
	else
		m_TabSettings.m_strRomFile = "o2rom.bin";


	if (GetPrivateProfileString("SETTINGS","SHOT_DIR","shots",szBuffer,512,strIniFile))
		m_TabSettings.m_strShotDir = szBuffer;
	else
		m_TabSettings.m_strShotDir = "shots";

	if (GetPrivateProfileString("SETTINGS","COVER_DIR","covers",szBuffer,512,strIniFile))
		m_TabSettings.m_strCoverDir = szBuffer;
	else
		m_TabSettings.m_strCoverDir = "covers";

	if (GetPrivateProfileString("SETTINGS","MANUAL_DIR","manuals",szBuffer,512,strIniFile))
		m_TabSettings.m_strManualDir = szBuffer;
	else
		m_TabSettings.m_strManualDir = "manuals";


	if (GetPrivateProfileString("SETTINGS","PICVIEWER","",szBuffer,512,strIniFile))
		m_TabSettings.m_strPictureViewer = szBuffer;
	else
		m_TabSettings.m_strPictureViewer = "";

	if (GetPrivateProfileString("SETTINGS","TEXTVIEWER","notepad.exe",szBuffer,512,strIniFile))
		m_TabSettings.m_strTextViewer = szBuffer;
	else
		m_TabSettings.m_strTextViewer = "notepad.exe";

	if (GetPrivateProfileString("SETTINGS","DEBUG","0",szBuffer,512,strIniFile))
		m_TabSettings.m_bDebug = atoi(szBuffer);
	else
		m_TabSettings.m_bDebug = FALSE;

	if (GetPrivateProfileString("SETTINGS","NOAUDIO","0",szBuffer,512,strIniFile))
		m_TabSettings.m_bNoAudio = atoi(szBuffer);
	else
		m_TabSettings.m_bNoAudio = FALSE;

	if (GetPrivateProfileString("SETTINGS","NOVOICE","0",szBuffer,512,strIniFile))
		m_TabSettings.m_bNoVoice = atoi(szBuffer);
	else
		m_TabSettings.m_bNoVoice = FALSE;

	if (GetPrivateProfileString("SETTINGS","SCANLINES","0",szBuffer,512,strIniFile))
		m_TabSettings.m_bScanlines = atoi(szBuffer);
	else
		m_TabSettings.m_bScanlines = FALSE;

	if (GetPrivateProfileString("SETTINGS","EUROMODE","0",szBuffer,512,strIniFile))
		m_TabSettings.m_bEuroMode = atoi(szBuffer);
	else
		m_TabSettings.m_bEuroMode = FALSE;

	if (GetPrivateProfileString("SETTINGS","ENABLEFILTER","0",szBuffer,512,strIniFile))
		m_TabSettings.m_bEnableFilter = atoi(szBuffer);
	else
		m_TabSettings.m_bEnableFilter = FALSE;

	if (GetPrivateProfileString("SETTINGS","FULLSCREEN","0",szBuffer,512,strIniFile))
		m_TabSettings.m_bFullscreen = atoi(szBuffer);
	else
		m_TabSettings.m_bFullscreen = FALSE;

	if (GetPrivateProfileString("SETTINGS","SPEEDLIMITER","0",szBuffer,512,strIniFile))
		m_TabSettings.m_bSpeedLimiter = atoi(szBuffer);
	else
		m_TabSettings.m_bSpeedLimiter = FALSE;


	if (GetPrivateProfileString("SETTINGS","AUDIO","100",szBuffer,512,strIniFile))
		m_TabSettings.m_nAudioVolume = atoi(szBuffer);
	else
		m_TabSettings.m_nAudioVolume = 100;

	if (GetPrivateProfileString("SETTINGS","VOICE","100",szBuffer,512,strIniFile))
		m_TabSettings.m_nVoiceVolume = atoi(szBuffer);
	else
		m_TabSettings.m_nVoiceVolume = 100;

	if (GetPrivateProfileString("SETTINGS","SPEED","100",szBuffer,512,strIniFile))
		m_TabSettings.m_nSpeed = atoi(szBuffer);
	else
		m_TabSettings.m_nSpeed = 100;

	if (GetPrivateProfileString("SETTINGS","WINDOW","1",szBuffer,512,strIniFile))
		m_TabSettings.m_WindowSize.SetCurSel(atoi(szBuffer));
	else
		m_TabSettings.m_WindowSize.SetCurSel(1);

	if (GetPrivateProfileString("SETTINGS","STICK1","1",szBuffer,512,strIniFile)){
		if (strlen(szBuffer)==1)
			m_TabSettings.m_Stick1.SetCurSel(atoi(szBuffer));
		else {
			m_TabSettings.m_Stick1.SetCurSel(-1);
			m_TabSettings.m_Stick1.SetWindowText(szBuffer);
		}
	} else
		m_TabSettings.m_Stick1.SetCurSel(1);

	if (GetPrivateProfileString("SETTINGS","STICK2","2",szBuffer,512,strIniFile)){
		if (strlen(szBuffer)==1)
			m_TabSettings.m_Stick2.SetCurSel(atoi(szBuffer));
		else {
			m_TabSettings.m_Stick2.SetCurSel(-1);
			m_TabSettings.m_Stick2.SetWindowText(szBuffer);
		}
	} else
		m_TabSettings.m_Stick2.SetCurSel(2);

	m_TabSettings.m_AudioSlider.SetPos(m_TabSettings.m_nAudioVolume);
	m_TabSettings.m_VoiceSlider.SetPos(m_TabSettings.m_nVoiceVolume);
	m_TabSettings.m_SpeedSlider.SetPos(m_TabSettings.m_nSpeed);
	
	return TRUE;
}

void CO2LauncherDlg::OnFileQuit() 
{
	// TODO: Add your command handler code here

	this->OnClose();
	this->EndDialog(0);
	
}

void CO2LauncherDlg::OnSelchangeTabs(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here

	CString strVal;

	strVal.Format("%d|%d",m_Tabs.GetItemCount(),MB_OK|MB_ICONINFORMATION);

	int nSelectedTab = m_Tabs.GetCurSel();

	m_Tabs.SetCurSel(nSelectedTab);
	
	switch(nSelectedTab)
	{
	case 0:
		if (m_TabSettings.refreshRoms)
			RefreshRomsList();
		m_TabRoms.ShowWindow(SW_SHOW);
		m_TabSettings.ShowWindow(SW_HIDE);
		m_TabRoms.UpdateData(FALSE);
		break;

	case 1:
		m_TabRoms.ShowWindow(SW_HIDE);
		m_TabSettings.ShowWindow(SW_SHOW);
		m_TabSettings.UpdateData(FALSE);
		m_TabSettings.refreshRoms = FALSE;
		break;


	}


	*pResult = 0;
}

void CO2LauncherDlg::OnSetFocus(CWnd* pNewWnd) 
{
	CDialog::OnSetFocus(pNewWnd);
	
	// TODO: Add your message handler code here

	
}

void CO2LauncherDlg::OnToolsCrccalculator() 
{
	// TODO: Add your command handler code here
	static char BASED_CODE szFilter[] = "Rom Files (*.bin)|*.bin";
	CChecksum checksum;

	////////////////////////////////////////////////////////

	char szOldDir[512];
	GetCurrentDirectory(512,szOldDir);

	////////////////////////////////////////////////////////

 

	CFileDialog fd(TRUE, 
					".bin",
					NULL,
					OFN_ENABLESIZING|OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST,
					szFilter,
					this);

	if (fd.DoModal()==IDOK)
	{
		CString strSection;
		unsigned long ulCrc = checksum.crc32_file(fd.GetPathName());
		strSection.Format("%08lX",ulCrc);

		CCrcDialog crc_dialog;
		crc_dialog.m_strFileName = fd.GetPathName();
		crc_dialog.m_strCRC = strSection;
		crc_dialog.DoModal();
	}

	SetCurrentDirectory(szOldDir);

	
}

void CO2LauncherDlg::OnToolsEmulatorkeys() 
{
	// TODO: Add your command handler code here
	CDialog dlg(IDD_KEYS_DIALOG);

	dlg.DoModal();
	
}


LRESULT CO2LauncherDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{

	// TODO: Add your specialized code here and/or call the base class

	
/*	CString strAux;

	strAux.Format("%d - %d - %d\n",message,wParam,lParam);

	FILE *arq;

	arq=fopen("log.txt","at");
	fprintf(arq,strAux);
	fclose(arq);*/


	return CDialog::WindowProc(message, wParam, lParam);
}

BOOL CO2LauncherDlg::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == WM_KEYDOWN) {
		switch (pMsg->wParam)
		{
		case VK_ESCAPE:
			return TRUE;
		case VK_RETURN:
			return TRUE;
		}
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}
